package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.grade.vo.ClassGradeUserGoodsVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.grade.bo.ClassGradeUserAddBo;
import com.zhongzheng.modules.grade.bo.ClassGradeUserQueryBo;
import com.zhongzheng.modules.grade.bo.ClassGradeUserEditBo;
import com.zhongzheng.modules.grade.domain.ClassGradeUser;
import com.zhongzheng.modules.grade.mapper.ClassGradeUserMapper;
import com.zhongzheng.modules.grade.vo.ClassGradeUserVo;
import com.zhongzheng.modules.grade.service.IClassGradeUserService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 学员记录Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-10
 */
@Service
public class ClassGradeUserServiceImpl extends ServiceImpl<ClassGradeUserMapper, ClassGradeUser> implements IClassGradeUserService {

    @Override
    public ClassGradeUserVo queryById(Long id){
        ClassGradeUser db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ClassGradeUserVo.class);
    }

    @Override
    public List<ClassGradeUserVo> queryList(ClassGradeUserQueryBo bo) {
        return entity2Vo(baseMapper.select(bo));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ClassGradeUserVo> entity2Vo(Collection<ClassGradeUserVo> collection) {
        List<ClassGradeUserVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ClassGradeUserVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ClassGradeUserVo> page = (Page<ClassGradeUserVo>)collection;
            Page<ClassGradeUserVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ClassGradeUserAddBo bo) {
        ClassGradeUser add = BeanUtil.toBean(bo, ClassGradeUser.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ClassGradeUserEditBo bo) {
        ClassGradeUser update = BeanUtil.toBean(bo, ClassGradeUser.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ClassGradeUser entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<ClassGradeUserGoodsVo> listUser(ClassGradeUserQueryBo bo) {
        return baseMapper.listUser(bo);
    }

    @Override
    public List<ClassGradeUserVo> listUserPeriod(ClassGradeUserQueryBo bo) {
        return null;
    }
}
